// PIN
int cible0=A0;
int cible1=A1;
int cible2=A2;
int pinServo1 = 5;
int pinServo2 = 6;
int pinServo3 = 7;
int pinBoutonStart = 8;
int pinBuzzer = 9;

// variable moyenne capteur lumiere
int moyennecible0=0;
int moyennecible1=0;
int moyennecible2=0;

// tableau pour savoir quelle cible est levee et peut etre toucher
int cibleCapteur[]={0,0,0};

int i = 0;
int start = 0;

// round de jeu tableau multi { temps en ms , numero servo , angle en degre } 15 pour plat et 90 pour levé , ajout valeur hors cadre a la fin
int round1[ ][ 3 ] = { { 1000, 0, 90 }, { 4000, 0, 15 } ,{ 4000, 2, 90 },{ 7000, 2, 15 },{ 7000, 1, 90 },{ 10000, 1, 15 },{ 11000, 0, 90 },{ 11000, 2, 90 },{ 14000, 0, 15 },{ 14000, 2, 15 },{ 15000, 1, 90 },{ 16000, 2, 90 },{ 18000, 1, 15 },{ 19000, 2, 15 },{ 20000, 2, 90 },{ 21000, 1, 90 },{ 22000, 0, 90 },{ 29000, 2, 15 },{ 29000, 1, 15 },{ 29000, 0, 15 },{ 61000, 0, 15 } };
int round2[ ][ 3 ] = { { 1000, 0, 90 },{ 3000, 1, 90 },{ 3000, 0, 15 },{ 5000, 1, 15 },{ 7000, 2, 90 },{ 7000, 0, 90 },{ 10000, 2, 15 },{ 10000, 0, 15 },{ 12000, 1, 90 },{ 13000, 0, 90 },{ 14000, 2, 90 },{ 15000, 1, 15 },{ 16000, 0, 15 },{ 17000, 2, 15 },{ 18000, 2, 90 },{ 19000, 1, 90 },{ 20000, 0, 90 },{ 20000, 2, 15 },{ 21000, 1, 15 },{ 22000, 0, 15 },{ 22000, 1, 90 },{ 23000, 0, 90 },{ 24000, 2, 90 },{ 29000, 0, 15 },{ 29000, 1, 15 },{ 29000, 2, 15 },{ 61000, 0, 15 } };
// temps des round , premier a 0 car se base sur la variable start ( start = 0 a l'init ) 
int tempsRound[]= {0,30000,30000};

// temps et step pour les sequences
long tempsdebut = 0;
long stepSequence = 0;

// points 
int points = 0;
int pointsManche = 0;

#include "pitches.h"
#include <Servo.h>

Servo monServo0;
Servo monServo1;
Servo monServo2;
Servo mesServos[]={monServo0,monServo1,monServo2};

// variable pour jouer les melodies
int numeroMelody = 0;
int numeroNote = 0;
int numeroNoteBefore = 9;
long tempsMelody = 0;
long pauseNotes;
bool boolMelody = 1;

// 2 melodies
int melody[][37] = {{
  NOTE_E4, NOTE_A4, NOTE_E4, NOTE_A4, NOTE_E4, NOTE_C4, NOTE_D4,NOTE_A3 ,0 
  ,NOTE_E4, NOTE_A4, NOTE_E4, NOTE_A4, NOTE_E4, NOTE_C4, NOTE_D4,NOTE_G4,0,
  NOTE_E4,NOTE_A4, NOTE_E4, NOTE_A4,NOTE_A4,NOTE_C5,NOTE_B4,NOTE_A4,NOTE_G4,0 
  ,NOTE_E4, NOTE_A4, NOTE_E4, NOTE_A4, NOTE_E4,0,NOTE_D4,NOTE_A3,NOTE_A3
},
{NOTE_E3,NOTE_A3,NOTE_E4,NOTE_C4,NOTE_G4,NOTE_G4,0}
}
;
// duree des notes des melodies
int noteDurations[][37] = {{
  16, 16, 16, 16, 2, 4, 4, 2,2 ,16, 16, 16, 16, 2, 4, 4, 2,2  ,16, 16, 16, 16,2,4,8,8,2,2,16,16,16,16,4,4,4,8,1
},{8,8,8,8,8,2,999} };



void setup() {

  Serial.begin(9600);
  pinMode(cible0,INPUT);
  pinMode(cible1,INPUT);
  pinMode(cible2,INPUT);  
  pinMode(pinBoutonStart,INPUT);

  // attacher les servos a leur pins
  unlockServos();

  delay(1000);
  // detache les servos de leur pins
  lockServos();

  // initialise les variables moyenne pour les capteur de luminosité
  //initSensorLight();
}

void loop() {

  // demarrer le jeu ?
  if(digitalRead(pinBoutonStart) == HIGH){
    start = 1;
    stopMusique();
    points = 0;
    
  }


  switch (start) {
    case 1:
    // round 1
        demarrerRound(tempsRound[start],round1);
      break;
    case 2:
    // round 2
        delay(2000);
        demarrerRound(tempsRound[start],round2);
      break;
    default: 
      // joue la melodie toutes les 60 scondes si le jeu n'est pas lancé
      if(millis() > tempsMelody+60000 ){
        numeroMelody=0;
        boolMelody = 1;
        numeroNote = 0;
        numeroNoteBefore = 9;       
      }
      // appelle jouer de la musique     
      jouerMusique();
    break;
  }

}


// initialisation des capteurs de lumiere pour capter le laser en phase de jeu
void initSensorLight(){
  int totalCible=0;
  //for each sensor catch 10 value for better aim
  for (i=0;i<10;i++) {
    totalCible+=analogRead(cible0);
  }
  moyennecible0=totalCible/10;
  totalCible=0;
  //for each sensor catch 10 value for better aim
  for (i=0;i<10;i++) {
    totalCible+=analogRead(cible1);
  }
  moyennecible1=totalCible/10;
  totalCible=0;
  //for each sensor catch 10 value for better aim
  for (i=0;i<10;i++) {
    totalCible+=analogRead(cible2);
  }
  moyennecible2=totalCible/10;
  totalCible=0; 

}


// avant de demarrer le jeu
void preStart(){
  
  pointsManche = 0;
  initSensorLight();
  
  Serial.println("3");
  tone(pinBuzzer,NOTE_FS4, 500);
  delay(1000);
  Serial.println("2");
  tone(pinBuzzer,NOTE_FS4, 500);
  delay(1000);
  Serial.println("1");
  tone(pinBuzzer,NOTE_FS4, 500);
  delay(1000);
  tone(pinBuzzer,NOTE_F5, 500);
}

// detacher les servo pour eviter les tremblements
void lockServos(){
  monServo0.detach();
  monServo1.detach();
  monServo2.detach();  
}
// attacher les servo pour les utiliser
void unlockServos(){
  monServo0.attach(pinServo1);
  monServo1.attach(pinServo2);
  monServo2.attach(pinServo3);
    
  monServo0.write(15);
  monServo1.write(15);
  monServo2.write(15);
}

// affiche le score de la manche( pour la v2 ) et jouer musique
void scoreManche(){

int tempsScore = millis ();
numeroMelody=1;
boolMelody = 1;
numeroNote = 0;
numeroNoteBefore = 9;
while(jouerMusique()== true){
   
}
// on joue la meoldie fin du stage

  Serial.print("Score Manche ");
  Serial.println(pointsManche);
  
}


// fonction qui gere les position des cible et les shots, an parametre le temps du round et le tableau des positions des servos 
void demarrerRound(int tempsTempo,int tempoRound[][3]){
  
      unlockServos();
      preStart();
      tempsdebut=millis();
      stepSequence = 0;
      while((millis()-tempsdebut) < tempsTempo){
        if(( millis() - tempsdebut ) >= tempoRound[ stepSequence ][ 0 ]){   
            
          mesServos[tempoRound[ stepSequence ][1]].write(tempoRound[ stepSequence ][2]);
          
          // autoriser un tir sur cible si valeur degré >89 ok pour cible sinon desactivé
          if(tempoRound[ stepSequence ][2]> 89){
            cibleCapteur[tempoRound[ stepSequence ][1]]=1;
          }
          else{
            cibleCapteur[tempoRound[ stepSequence ][1]]=0;
          }
          
          stepSequence++;
        }
        
        // sequence pour receptionner les signaux
        if(cibleCapteur[0] == 1 ){
            if(analogRead(cible0)> moyennecible0 + 50){
                monServo0.write(15); 
                pointsManche++;
                  // init cible pour eviter plusieurs tirs et points
                cibleCapteur[0] = 0;
                Serial.println(" Cible 0 Touche");
                tone(pinBuzzer,NOTE_DS8, 500);                
            }
        }

        if(cibleCapteur[1] == 1 ){
            if(analogRead(cible1)> moyennecible1 + 50){
                monServo1.write(15); 
                pointsManche++;
                  // init cible pour eviter plusieurs tirs et points
                cibleCapteur[1] = 0;
                Serial.println(" Cible 1 Touche");
                tone(pinBuzzer,NOTE_DS8, 500); 
            }
        }

        if(cibleCapteur[2] == 1 ){
            if(analogRead(cible2)> moyennecible2 + 50){
                monServo2.write(15); 
                pointsManche++;
                  // init cible pour eviter plusieurs tirs et points
                cibleCapteur[2] = 0;
              Serial.println("Cible 2 Touche");
              tone(pinBuzzer,NOTE_DS8, 500); 
            }
        }

        
      }
      
      start++;
      lockServos();
      scoreManche(); 

}

// fonction jouer de la musique pour jouer le theme hors jeu et pendant les phases de score
bool jouerMusique(){

  if( boolMelody == 1 ){


  // depart du temps de reference de la melodie au temps 0
        if(numeroNote == 0){
          tempsMelody=millis();
        }

          // durée de la note en cours
        int noteDuration = 1000 / noteDurations[numeroMelody][numeroNote];

        if(numeroNote != numeroNoteBefore){
            numeroNoteBefore=numeroNote;     
            tone(pinBuzzer, melody[numeroMelody][numeroNote], noteDuration);
  
        // ici on calcule le temps qu'il faut avant de passer a la step suivante ( note suivante )
        pauseNotes = (noteDuration * 1.30) ;
        pauseNotes+=tempsMelody;

        }
  
        if(millis() >= pauseNotes){
            numeroNote+=1;
            tempsMelody=millis();
        }
        if(numeroNote >= (sizeof(noteDurations[numeroMelody])/sizeof(int)) || noteDurations[numeroMelody][numeroNote] == 999 ){
           boolMelody = 0;
           numeroNote = 0;
           numeroMelody = 0;
           numeroNoteBefore = 9;
           noTone(pinBuzzer);
           return false;
        }
  }  
  return true;
}

// arrete la musique
void stopMusique(){
  boolMelody = 0;
  numeroNote = 0;
  numeroMelody = 0;
}

